#define voieA PIN_B3
#define voieB PIN_B7
// PAs AB

//0 00
//1 01
//2 11
//3 10

volatile unsigned int pas_encours;
const unsigned short horaire=true;
const unsigned short antihoraire=false;

void init_pas(void)
{
 pas_encours = 0;
 output_low(voieA);
 output_low(voieB);
}

void rotation_un_pas(unsigned short sens)
 {
  switch (pas_encours) {
   case 0: 
       if (sens==horaire) {pas_encours = 1; output_high(voieB);}
       else {pas_encours = 3; output_high(voieA);}
    break;
   case 1: ;
       if (sens==horaire) {pas_encours = 2; output_high(voieA);}
       else {pas_encours = 0; output_low(voieB);}
      break;
   case 2: ;
       if (sens==horaire) {pas_encours = 3; output_low(voieB);}
       else {pas_encours = 1; output_low(voieA);}
     break;      
   case 3: ;
       if (sens==horaire) {pas_encours = 0; output_low(voieA);}
       else {pas_encours = 2; output_high(voieB);}
     break;       
   default: init_pas();
      break; }
 }

void rotation_n_pas(unsigned int nombre_pas,unsigned long int duree_pas_us,unsigned short sens)
 {
  unsigned int i;
  for (i=0;i<nombre_pas;i++)
   {
    rotation_un_pas(sens);
    delay_us(duree_pas_us);
   }
  }
